import gc
try: xrange
except: xrange = range


def multiplode (n, m):
	r = (n == n // m * m)
	return r


def calcularR (pN, largo, zeta, limiteMem=100000, mostrar=False):

		if pN > largo * zeta:
			return 0

		# aprovechar simetria
		mitad = (largo * zeta) // 2
		N = pN if pN <= mitad else zeta * largo - pN

		default = [None] * (largo)
		default[1] = 1

		# ---------------- calcular R (largo, magnitud) ---------------

		R = {}

		sufijo_max = [zeta * (L - 1) for L in xrange (largo + 1)]

		mem = [1 for n in xrange (largo + 1)]
		s0mem = [0 for n in xrange (largo + 1)]
		s1mem = [0 for n in xrange (largo + 1)]

		descartado = -1

		for n in xrange (N + 1):
			R[n] = default[:]
			for L in xrange (2, largo + 1):
				if n < zeta * L + 1:

					# calcular rango del prefijo (p0, p1) y del sufijo (s0, s1)
					p0 = max (0, n - sufijo_max[L])
					p1 = min (zeta, n)
					s0 = n - p1
					s1 = n - p0

					# sumar el ultimo si s1 aumenta, restar el primero anterior si s0 aumenta
					s0g = s0mem[L]
					dif = R[s1][L - 1] if s1 > s1mem[L] else 0
					dif -= R[s0g][L - 1] if s0 > s0g else 0
					mem[L] += dif

					# guardar
					if not L == largo:
						R[n][L] = mem[L]
					s1mem[L] = s1
					s0mem[L] = s0


			if multiplode (n, limiteMem):
				# mostrar progreso
				if mostrar:
					print ('%s/%s' % (n, N))
				# descartar memoria
				d = min (s0mem[2:] + s1mem[2:])
				if d > descartado + 1:
					for m in xrange (descartado + 1, d):
						R.pop (m, None)
					gc.collect ()
					descartado = d - 1

		return mem[largo]


# ----------------------------------------------------------------
if __name__ == '__main__':
	from math import log

	N = 70
	largo = 64
	zeta = 7

	r = calcularR (N, largo, zeta)

	print ('N, largo, zeta = ' + str ((N, largo, zeta)))
	print ('R = ' + str (r))
	print ('R = 2^' + str (log (r, 2)))

