from hashlib import sha256, sha512
from __aplicarUps import aplicarUps
from __comprimir import comprimir
from __expandir import expandir
import os

def crearfuncion_claves (largo, zeta, comprimido, consal, cbits, upbits):

	def crearclaves ():
		sal = sha256 (os.urandom (64)).digest () if consal else b''

		seed = sha512 (os.urandom (128)).digest ()
		clavepriv = expandir (seed, upbits, largo)

		# aplicar ups
		z = [zeta] * largo
		clavepub = aplicarUps (clavepriv, ups=z, sal=sal, inicio=True, zeta=zeta)

		priv = {'clave': seed if comprimido else clavepriv, 'sal': sal}
		pub = comprimir (clavepub, cbits) if comprimido else clavepub
		return priv, pub

	return crearclaves


# ----------------------------------------------------------------
if __name__ == '__main__':

	largo, zeta = 4, 10
	cbits = 100

	crearclaves = crearfuncion_claves (largo, zeta, comprimido=True, consal=True, cbits=64, upbits=64)
	priv, pub = crearclaves ()

	print ('pub = ' + repr (pub))

