from itertools import count
from __aplicarUps import aplicarUps
from __composicion import composicion
from __comprimir import comprimir
from __hashA import hashA
from __hashB import hashB
from __separar import separar


def crearfuncion_verificar (N, largo, zeta, M, comprimido, cbits, mbits):

	def verificar (mensaje, firma=b'', n=b'0', sal=b'', pub=b''):
		try:
			mensajeBytes = mensaje if type (mensaje) == bytes else mensaje.encode ('utf-8')

			# aplicar hash con sal al mensaje
			h = hashA (sal + mensajeBytes, mbits)

			# aplicar hash con el contador al mensaje
			m = hashB (n + h, mbits)
			if m >= M: return False

			# obtener composicion
			c = composicion (N, largo, indice=m)
			if max (c) > zeta: return False

			# aplicar ups
			f = separar (firma, largo)
			p = aplicarUps (f, ups=c, sal=sal, inicio=False)

			# testear
			test = comprimir (p, cbits) if comprimido else p
			valido = (test == pub)
			return valido

		except:
			return False

	return verificar


# ----------------------------------------------------------------
if __name__ == '__main__':

	N, largo, zeta = 10, 4, 10
	M, mbits = 1716, 11
	verificar = crearfuncion_verificar (N, largo, zeta, M, comprimido=True, cbits=64, mbits=mbits)

	pub = b'123'
	mensaje = 'abc'
	firma = b'firma invalida'
	n = b'0'
	sal = b''

	v = verificar (mensaje, firma=firma, n=n, sal=sal, pub=pub)

	print (v == False)

