from __b64 import b64
from __calcularM import calcularM
from __crearfuncion_claves import crearfuncion_claves
from __crearfuncion_firmar import crearfuncion_firmar
from __crearfuncion_verificar import crearfuncion_verificar
import __constantes as constantes


def ic_ots (bits=256, largo=28, tipo='a'):
	# parametros	
	upbits = bits
	cbits = bits
	consal = True
	comprimido = True
	if tipo in ('sig', 'aprox', 'ver'):
		tipo = tipo[0]

	try:
		N = constantes.N[tipo][(bits, largo)]
		zeta = constantes.zeta[tipo][(bits, largo)]
	except:
		raise ValueError ('parametros incorrectos')
	M, mbits = calcularM (N, largo)

	# crear funciones
	crearclaves = crearfuncion_claves (largo, zeta, comprimido, consal, cbits, upbits)
	firmar = crearfuncion_firmar (N, largo, zeta, M, comprimido, mbits, upbits)
	verificar = crearfuncion_verificar (N, largo, zeta, M, comprimido, cbits, mbits)

	return crearclaves, firmar, verificar


# ----------------------------------------------------------------
if __name__ == '__main__':

	crearclaves, firmar, verificar = ic_ots (bits=128, largo=14, tipo='a')

	# crear claves
	priv, pub = crearclaves ()

	# firmar
	mensaje = 'abc'
	firma, n, sal = firmar (mensaje, priv=priv)

	# verificar
	v = verificar (mensaje, firma, n, sal, pub=pub)

	print ('pub = ' + b64 (pub))
	print ('\nfirma = ' + b64 (firma))
	print ('n = ' + n.decode ('ascii'))
	print ('sal = ' + b64 (sal))
	print ('\nverificar = ' + str (v))

