from hashlib import sha256, sha512
try: xrange
except: xrange = range


def crear_hashUp (sal=b'', upbits=256):
	tbytes = (upbits + 7) // 8
	padding =  b'\x00' * ((64 - len (sal)) % 64)
	Hsal = sha512 (sal + padding) if upbits > 256 else sha256 (sal + padding)

	def hashUp (m, iterar=1, x=0, y=0):
		h = m
		for yn in xrange (y, y - iterar, -1):
			c = b'%x %x' % (x, yn)
			Hn = Hsal.copy ()
			Hn.update (h + c)
			h = Hn.digest ()[0:tbytes]
		return h

	return hashUp


# ----------------------------------------------------------------
if __name__ == '__main__':

	m = b'abc'
	sal = b'123'

	hashUp = crear_hashUp (sal)
	h = hashUp (m)

	print ('m = ' + repr (m))
	print ('sal = ' + repr (sal))
	print ('hash (m, iterar=1, sal=sal) = ' + repr (h))

